* make sure all tables are closed
clos all

* open the relevant tables
use address in 0 order companyid
use company in 0 order companyid
use contact in 0 order companyid

* set relations between the tables
select address
set relation to companyid into company

* local variables for recording which company ID 
* we're currently checking and how many
* addresses that ID has
local lnAddresses, lnCompanyID
* initialise the variables
lnAddresses = 0
lnCompanyID = address.companyid

* loop through all of the records in the address table
scan

  * if this is the same companyid as the last record
  * increment the number of addresses this company has
  if lnCompanyID = address.companyid
    lnAddresses = lnAddresses + 1
  
  * otherwise, this is the new company's first address
  else
    lnAddresses = 1
  endif
  
  * if this is the company's second address, then this
  * company meets the criterion and we should print
  * its name and the name of its contacts
  * only do this for address 2, otherwise we'll get
  * duplicates
  if lnAddresses = 2
  
    * loop through the company's contacts
    * the company table's pointer is on the correct
    * record because of the relation
    select contact
    scan for companyid = lnCompanyID
      ? contact.firstname, contact.familyname, ;
        company.companyname
    endscan
    
    * go back to the address table
    select address
  endif
  
  * save this record's company ID for comparison with
  * the next record's
  lnCompanyID = address.companyID

endscan

* clean-up code omitted
